//+------------------------------------------------------------------+
//|                         Server_Synch_within_Custom_Indicator.mq4 |
//|                                            Copyright  2010, LOL |
//|                                             http://www.noone.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, 1005phillip"
#property link      "http://www.1005phillip.com"

#property indicator_separate_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

extern bool SyncServerData=true,verbose=true;

int      i,j,ServerSyncTimeFrame,sleep_seconds;
string   CurrentSymbol;

int init()
  {
//---- indicators
   // Synchronize the memory-resident historical price data so that the EA and indicators on other timeframes have access to recent data
   if(SyncServerData==true)
      {
      CurrentSymbol=Symbol();
      sleep_seconds=5;
      for(i=1;i<=9;i++)
         { // i looping for M1-MN1 History Files
         switch(i)
            {
            case 1   :  ServerSyncTimeFrame=1;  break; // Synchronize M1 Timeframe data with the server
            case 2   :  ServerSyncTimeFrame=5;  break; // Synchronize M5 Timeframe data with the server
            case 3   :  ServerSyncTimeFrame=15;  break; // Synchronize M15 Timeframe data with the server
            case 4   :  ServerSyncTimeFrame=30;  break; // Synchronize M30 Timeframe data with the server
            case 5   :  ServerSyncTimeFrame=60;  break; // Synchronize M60 Timeframe data with the server
            case 6   :  ServerSyncTimeFrame=240;  break; // Synchronize M240 Timeframe data with the server
            case 7   :  ServerSyncTimeFrame=1440;  break; // Synchronize M1440 Timeframe data with the server
            case 8   :  ServerSyncTimeFrame=10080;  break; // Synchronize M10080 Timeframe data with the server
            case 9   :  ServerSyncTimeFrame=43200;  break; // Synchronize M43200 Timeframe data with the server
            default  :  Print("Error encountered in the SWITCH routine for setting the timeframe for server data synchronization"); return(0);// The expression did not generate a case value
            }
         
         j=0; // initialize the while loop counter
         while(j<10 && (iClose(CurrentSymbol,ServerSyncTimeFrame,2)==0 || GetLastError()==4066)) // call the iClose() function with a shift of 2 to ensure we sample the timeseries in a likely unsynchronized span
            {
            j++; // increment the while loop counter
            if(verbose==true) Print("Sync cycle ",j,": Sleeping for ",sleep_seconds," seconds to let the server synchronize with requested date for Period M",ServerSyncTimeFrame);
            Sleep(sleep_seconds*1000); // sleep to give the server time to update the local hst file
            }
         if(j==10)
            {
            Print("Failed to synchronize the hst data with the server after ",j," cycles and ",j*sleep_seconds," seconds");
            return(0);
            }
         }
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+